/**
 * @author Antti
 */
package gfx { 
	import flash.display.*;
	import flash.geom.*;
	import flash.text.*;
	import flash.events.*;
	
	public class Button extends Sprite {
		
		// _________________________________________________________________________
		// VARIABLES
		
		protected var title_text		: TextField;
		protected var button			: SimpleButton = new SimpleButton( );
		
		// _________________________________________________________________________
		// CONSTRUCTOR
		
		public function Button( button_title : String, size : Rectangle, textFormat : TextFormat ) {
			
			var up : Shape = new Shape( );
				up.graphics.beginFill( 0xEEEEEE );
				up.graphics.drawRoundRect( 0, 0, size.width, size.height, 16, 16 );
				up.graphics.endFill( );
			
			var over : Shape = new Shape( );
				over.graphics.beginFill( 0xDDDDDD );
				over.graphics.drawRoundRect( 0, 0, size.width, size.height, 16, 16 );
				over.graphics.endFill( );
			
			var down : Shape = new Shape( );
				down.graphics.beginFill( 0xCCCCCC );
				down.graphics.drawRoundRect( 0, 0, size.width, size.height, 16, 16 );
				down.graphics.endFill( );
			
			var hit : Shape = new Shape( );
				hit.graphics.beginFill( 0xFF00FF );
				hit.graphics.drawRect( 0, 0, size.width, size.height );
				hit.graphics.endFill( );
			
		    button.upState = up;
		    button.overState = over;
		    button.downState = down;
		    button.useHandCursor = true;
		    button.hitTestState = hit;
		    
		    title_text = new TextField( );
		    title_text.selectable = false;
		    title_text.embedFonts = true;
		    textFormat.align = "center";
		    title_text.defaultTextFormat = textFormat;
		    title_text.width = size.width;
		    title_text.text = button_title;
		    title_text.y = 5;
		    title_text.mouseEnabled = false;
		    
		    addChild( button );
		    addChild( title_text );
			
		}
		
		// _________________________________________________________________________
		// PUBLIC API METHODS
		
		public function set title( newTitle : String ) : void {
			title_text.text = newTitle;
		}
		
		override public function set mouseEnabled( newEnabled : Boolean ) : void {
			button.mouseEnabled = newEnabled;
		}
		
	}
}