﻿/**
 * @author Antti
 */
 package gfx {
 	
	import flash.display.*;
	import flash.text.*;
	import flash.display.*;
	import flash.geom.Rectangle;
	import flash.events.*;
	 
	public class Form extends Sprite {
		
		// _________________________________________________________________________
		// CLASS CONSTANTS
		
		static public const SUBMIT	: String = "Submit";
	 	
		// _________________________________________________________________________
		// SETTINGS
		
		protected var EXTEND_BG		: Number = 8;
		protected var FORM_WIDTH		: int = 450;
		
		// _________________________________________________________________________
		// VARIABLES
		
		protected var logo			: TextField;
		protected var versionField	: TextField;
		protected var ingress			: TextField;
		protected var inputField		: TextField;
		protected var inputBg			: Sprite;
		protected var submitButton	: Button;
		
		// _________________________________________________________________________
		// CONSTRUCTOR
		
		public function Form() {
			super();
			
			createGfx( );
		}
		
		// _________________________________________________________________________
		// PROTECTED METHODS
		
		protected function createGfx( ) : void {
			logo = new TextField( );
				logo.embedFonts = true;
				logo.autoSize = TextFieldAutoSize.LEFT;
				logo.selectable = false;
				logo.antiAliasType = AntiAliasType.ADVANCED;
				
			var logoStyle : TextFormat = new TextFormat( );
				logoStyle.font = "myriad";
				logoStyle.letterSpacing = 1.5;
				logoStyle.size = 30;
				
				logo.defaultTextFormat = logoStyle;
				logo.text = Main.TITLE;
				
			versionField = new TextField( );
				versionField.embedFonts = true;
				versionField.selectable = false;
				versionField.antiAliasType = AntiAliasType.ADVANCED;
			
			var versionFieldStyle : TextFormat = new TextFormat( );
				versionFieldStyle.font = "myriad";
				versionFieldStyle.size = 8;
				versionFieldStyle.color = 0x808080;
				
				versionField.defaultTextFormat = versionFieldStyle;
				versionField.text = Main.VERSION;
				versionField.x = logo.textWidth;
				versionField.y = 2;
			
			ingress = new TextField( );
				ingress.embedFonts = true;
				ingress.autoSize = TextFieldAutoSize.LEFT;
				ingress.selectable = false;
				ingress.antiAliasType = AntiAliasType.ADVANCED;
				ingress.y = 50;
				
			var ingressStyle : TextFormat = new TextFormat( );
				ingressStyle.font = "myriad";
				ingressStyle.size = 12;
				
				ingress.defaultTextFormat = ingressStyle;
				ingress.text = "Enter the name of an artist you like";
				
			inputBg = new Sprite( );
				inputBg.graphics.beginFill( 0xEEEEEE );
				inputBg.graphics.drawRoundRect( 0, 0, FORM_WIDTH + EXTEND_BG, 25, EXTEND_BG * 2, EXTEND_BG * 2 );
				inputBg.graphics.endFill( );
				inputBg.x = -EXTEND_BG / 2;
				inputBg.y = 70;
				
			inputField = new TextField( );
				inputField.embedFonts = true;
				inputField.width = FORM_WIDTH - 6;
				inputField.type = TextFieldType.INPUT;
				inputField.height = 15;
				inputField.y = 74;
				inputField.x = 3;
				
			var inputStyle : TextFormat = new TextFormat( );
				inputStyle.font = "myriad";
				inputStyle.size = 14;
				
				inputField.defaultTextFormat = inputStyle;
				inputField.text = "Artist name"; //"Artist name";
				
			var submitTextStyle : TextFormat = new TextFormat( );
				submitTextStyle.font = "myriad";
				submitTextStyle.size = 12;
				submitTextStyle.align = "center";
				
			submitButton = new Button( "find similar", new Rectangle( 0, 0, 100, 25 ), submitTextStyle );
				submitButton.x = FORM_WIDTH - submitButton.width;
				submitButton.y = 104;
				submitButton.addEventListener( MouseEvent.CLICK, clickHandler );
			
			addChild( logo );
			addChild( versionField );
			addChild( ingress );
			addChild( inputBg );
			addChild( inputField );
			addChild( submitButton );	
		}
		
		// _________________________________________________________________________
		// EVENT HANDLERS
		
		protected function clickHandler( e : Event ) : void {
			dispatchEvent( new Event(SUBMIT) );
		}
		
		// _________________________________________________________________________
		// PUBLIC API METHODS
		
		public function get artist( ) : String {
			return inputField.text;
		}
		
		public function set enabled( newEnabled : Boolean ) : void {
			inputField.mouseEnabled = newEnabled;
			submitButton.mouseEnabled = newEnabled;
		}
		
	}
}