/**
 * @author Antti
 */
 package gfx {
 	
	import flash.display.*;
	import flash.geom.*;
	 	
	public class ReflectedBitmapData extends BitmapData {
		
		// _________________________________________________________________________
		// SETTINGS
		
		protected var spacing			: int = 1;
		
		// _________________________________________________________________________
		// CONSTRUCTOR
		
		function ReflectedBitmapData( data : BitmapData, length : Number, alpha : Number) {
			super( data.width, data.height * 2, true, 0x00000000 );
			
			draw( data );

			var l : Number = length/100;
						
			var reflection : BitmapData = new BitmapData( data.width, data.height * l, true, 0x00000000 );
            var flipMatrix:Matrix = new Matrix(1, 0, 0, -1, 0, reflection.height / l);
            reflection.draw( data, flipMatrix, new ColorTransform(alpha/100, alpha/100, alpha/100, 1, 0, 0, 0, 0) );         
            
            // Fade
            var holder:Shape = new Shape();
            var gradientMatrix:Matrix = new Matrix();
            gradientMatrix.createGradientBox( reflection.width, reflection.height, Math.PI/2 );
            
            holder.graphics.beginGradientFill( GradientType.LINEAR, [ 0, 0 ], [ 0, 100 ], [ 0, 0xFF ], gradientMatrix)
            holder.graphics.drawRect(0, 0, reflection.width, reflection.height);
            holder.graphics.endFill();
             
            reflection.draw( holder );
            var matrix : Matrix = new Matrix( );
            	matrix.translate( 0, data.height + spacing );
            draw( reflection, matrix );  
            
			data.dispose( );
			reflection.dispose( );
		}

	}
}