/**
 * @author Antti
 */
 
 package media {
 	
 	import flash.media.*;
 	import flash.net.*;
	import flash.events.*;
	
	import mx.effects.Tween;
	import mx.effects.easing.*;
	import mx.events.*;
	
	public class Song extends EventDispatcher {
		
		protected var mp3_parser				: String = "http://www.anttikupila.com/parse_mp3.php?url=";
		
		protected var sound					: Sound;
		protected var soundChannel			: SoundChannel;
		protected var loader					: URLLoader;
		
		protected var _artist					: String;
		protected var _title					: String;
		protected var _info					: String;
		protected var path					: String;
		protected var playing					: Boolean;
		
		protected var volumeTween				: Tween;
		
		function Song( artist : String, title : String, infoUrl : String ) : void {
			
			_artist = artist;
			_title = title;
			_info = infoUrl;
			
			loader = new URLLoader( );
			loader.addEventListener( Event.COMPLETE, idParsedHandler );
			
			sound = new Sound( );
			sound.addEventListener( Event.COMPLETE, soundEndHandler );
			
			volumeTween = new Tween( this, 0, 1, 3000, 25 );
			volumeTween.setTweenHandlers( soundFadeHandler, soundFadeHandler );
			volumeTween.pause( );
		}
		
		public function play( ) : void {
			if ( playing ) return;
			if ( !path ) {
				loader.load( new URLRequest( mp3_parser + _info ) );
			} else {
				try {
					sound.load( new URLRequest( path ) );
					soundChannel = sound.play( );
					volumeTween.resume( );
				} catch( e : SecurityError ) {
	                trace( e );
	            }
			}
		}
		
		public function close( ) : void {
			if ( playing ) {
				volumeTween.pause( );
				volumeTween = new Tween( this, soundChannel.soundTransform.volume, 0, 2000, 25 );
				volumeTween.setTweenHandlers( soundFadeHandler, soundFadeHandler );
				try {
					loader.close( ) ; // cancel load
				} catch ( e : Error ) {
					trace( e );
				}
			} else {
				disconnect( );
			}
		}
		
		public function disconnect( ) : void {
			trace( "Disconnecting " + toString( ) );
			playing = false;
			try {
				loader.close( ) ; // cancel load
			} catch ( e : Error ) {
				trace( e );
			}
			try {
				
				sound.close( );
			} catch ( e : Error ) {
				trace( e );
			}
			trace( "Disconnected" );
		}	
		
		override public function toString( ) : String {
			return "Song: " + _artist + " - " + _title;
		}
		
		// EVENT HANDLERS
		
		protected function idParsedHandler( e : Event ) : void {
			path = String( e.target.data );
			trace( "Filename: " + e.target.data );
			if (path != "false") {
				trace( "Song initialized" );
				dispatchEvent( new Event( Event.INIT ) );
				play( );
				playing = true;
			} else {
				dispatchEvent( new Event( Event.UNLOAD ) );
			}
		}
		
		protected function soundEndHandler( e : Event ) : void {
			trace(toString + " completed");
			playing = false;
			dispatchEvent( new Event( Event.SOUND_COMPLETE ) );
		}
		
		protected function soundFadeHandler( volume : Number ) : void {
			trace( "volume: " + volume );
			var transform : SoundTransform = soundChannel.soundTransform;
			transform.volume = volume;
			soundChannel.soundTransform = transform;
			if ( volume <= 0 ) disconnect( );
		}
	}
 }